<template>
  <div class="nonregular-order">
    <ObLoader :size="80" />
  </div>
</template>

<script>
import api from "@/api";
import { uuid } from "vue-uuid";
import { draftFactory } from "@/resources/order";
import { mapMutations, mapGetters } from 'vuex';

import ObLoader from 'common-components/src/obComponents/obLoader';

  export default {
    name: 'orderDraftNonRegualar',

    components: {
      ObLoader
    },

    computed: {
      ...mapGetters({
        role: "user/role",
        contractorUuid: "user/participantUuid",
      }),
    },

    async created() {
      if (!this.role) {
        this.setTokenData()
      }
      try {
        if (this.role && this.role !== 'clicar') {
          this.$router.push(`/404`);
          return
        }
        const newUUID = uuid.v4();        
        const number = await api.orders.getOrderId('Nonregular Order');
        const payload = draftFactory(number.data.code, 'NONREGULAR');
        
        payload.bodySaveDraft.contractorUuid = this.contractorUuid;

        payload.creators = {
          userUuid: this.userUuid,
          contractorUuid: this.contractorUuid,
        };

        const saved = await api.orders.saveOrder(newUUID, payload);
        const transboundary = await this.saveRoute(newUUID, payload.bodySaveDraft.route);

        if (transboundary) {
          payload.bodySaveDraft.route.transboundary = transboundary;
        }

        if (saved) {
          this.$router.push(`/order-drafts-item/${newUUID}`)
        }
      } catch (error) {
        console.error(error);
      }
    },

    methods: {
      ...mapMutations({
        setTokenData: 'user/setTokenData'
      }),

      async saveRoute(uuid, route) {
        try {
          const res = await api.orders.saveRoute(uuid, route)
          return res.transboundary;
        } catch (err) {
          console.error(err);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка сохранения маршрута",
          });
        }
      },
    }
  }
</script>

<style lang="scss" scoped>
  .nonregular-order {
    display: flex;
    width: 100%;
    justify-content: center;
    align-items: center;
  }
</style>